#pragma once

#include "CoreMinimal.h"
#include "Skill.h"
#include "UObject/NoExportTypes.h"
#include "RevealGeneratorsClosestToEachOtherSkill.generated.h"

class AGenerator;

UCLASS(Blueprintable, meta=(BlueprintSpawnableComponent))
class CALAMARI_API URevealGeneratorsClosestToEachOtherSkill : public USkill
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	int32 _generatorsToRevealCount;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FLinearColor _generatorAuraColor;

	UPROPERTY(BlueprintReadWrite, ReplicatedUsing=OnRep_RevealedGenerators, Transient, meta=(AllowPrivateAccess=true))
	TArray<AGenerator*> _revealedGenerators;

private:
	UFUNCTION(BlueprintCallable)
	void OnRep_RevealedGenerators(TArray<AGenerator*> oldRevealedGenerators);

	UFUNCTION(BlueprintCallable)
	void OnIntroCompleted();

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	URevealGeneratorsClosestToEachOtherSkill();
};

FORCEINLINE uint32 GetTypeHash(const URevealGeneratorsClosestToEachOtherSkill) { return 0; }
